 /**********************************************************************

	file.c
	file handling

	Mark Loveland 	5/10/96

***********************************************************************/
#include "file.h"

void Open(filename)
const char *filename;
{
	FILE* stor;

	if ((stor = fopen(filename, "w+")) == NULL)
	{
		 printf("Problems opening this file.\n");
		 exit(1);
	}
	fclose(stor);
}

int Insert(buf, size, index, filename)
char* buf; 
int size; 
int index;
const char *filename;
{
	int fd;
	if ((fd = open(filename,O_WRONLY)) == -1)
	{
		printf("The file would not open.\n");
		exit(1);
	}
	lseek(fd,index,0);
	write(fd,buf,size);
	close(fd);
	return 1;
}

int Append(buf, size, filename)
char* buf; 
int size; 
const char*filename;
{
	int fd;
	if ((fd = open(filename,O_WRONLY)) == -1)
	{	
		printf("The file would not open.\n");
		exit(1);
	}
	lseek(fd,0L,2);
	write(fd,buf,size);
	close(fd);
	return 1;
}


void Read(offset, buf, count, filename)
int offset; 
char* buf; 
int count; 
const char *filename;
{
	int fd;
	if ((fd = open(filename,O_RDONLY)) == -1)
	{
		 printf("The file would not open.\n");
		 exit(1);
	}
	lseek(fd,offset,0);
	read(fd,buf,count);
	close(fd);
}

